   ;   5_1( )
   ; -
 
   ; M/K  89C2051
   ; F=8M
     
	$MOD2051

	TAX	EQU	3FH		; 
	BDL	EQU	7DH		; 
	STK	EQU	39H		; 
	TMR	EQU	78H		; 
	NOPP	EQU	00H		; 
	REG	EQU	73H		; 
	CLOK	EQU	66H		; 

	A0	BIT	P1.0
	A1	BIT	P1.1
	A2	BIT	P1.2
	A3	BIT	P1.3
	BUD1	BIT	P1.4
	KP	BIT	P1.5
	TR	BIT	P1.6
	ZV	BIT	P1.7
	DI	BIT	P3.0
	CLK	BIT	P3.1
	KM	BIT	P3.2
	KR	BIT	P3.3
	KH	BIT	P3.4
	DT	BIT	P3.5
	EI	BIT	P3.7

K1		EQU	20 		;K2*20=1s			(10)
K2		EQU	15535		;(50000*12)/(Ft*1000)ms 	(32201)
KIND		EQU	64202 		;2ms

;55* 9= 500(2ms),8/12=2*1000000/3
;2*1000000/3/500=(2*1000000)/(3*500)=1333
;65535-1333=64202
;==========================================================
		BSEG
		ORG	00H
FLKN:		DBIT	1	; .
FLPS:		DBIT	1	; .	
FLIM:		DBIT	1	; 
FTIM:		DBIT	1	;  
FON1:		DBIT	1	; ..1
FOF1:		DBIT	1	; ..1
FCLK:		DBIT	1	; 
;==========================================================
		DSEG
		ORG	30H
BUFT:		DS	1	;(30H) .
TSEC:		DS	1	;(31H) 0.050
TIM:		DS	3	;(32H)  (****)
				; 
PZ:		DS	2	;(35H) .- . 
BUFB:		DS	4	;(37H)  -
BTPR:		DS	1	;(3BH)   -
BHPZ:		DS	1	;(3CH)  - - -
BUFM:		DS	1	;(3DH)  .
BFVB:		DS	1	;(3EH)  / -
BFET:		DS	6	;(3FH)  .  -(****)
				;. .
ZD:		DS	1	;(45H) 
BF1:		DS	1	;(46H)  -   - 
BF2:		DS	1	;(47H)  -   - 
INFS:		DS	9	;(48H) .(****)
				;   
BFVR:		DS	6	;(51H) . .
BFIS:		DS	1	;(57H)  .(INFS)
ADIS:		DS	1	;(58H) ...
CNTX:		DS	1	;(59H) ..(0-2.1-4.)(****)
				; 

;==========================================================
		CSEG
      	ORG 0000H			;
      	JMP START		;

      	ORG 0003H			;
 	RETI              		;

      	ORG 000BH		; TC0
	JMP IND			; 

      	ORG 0013H			;
      	RETI              		;

      	ORG 001BH		; TC1
	RETI			;

      	ORG 0023H			;
      	RETI              		;
;==========================================================
START:	MOV	R1,	#0		; 
      	MOV	R2,	#0		;
      	MOV	R3,	#0		;
      	MOV	R4,	#0		;
      	MOV	R5,	#0		;   .
      	MOV	R6,	#0		; .( -)
      	MOV	R7,	#0		;

      	MOV	P1,	#0FFH	     	;
      	MOV	P3,	#0FFH 	   	;

      	MOV	BFIS,	#INFS+8 	   	;
      	MOV	ADIS,	#07H	     	; .- -
      	MOV	BUFT,	#80H   	   	; CONST .
      	CLR	FLPS      			;   
       	CLR	FCLK      			;   -
     	MOV	BUFM,	#0FFH    	 	;
      	MOV	TSEC,	#0		;
      	MOV	BFVB,	#0FFH    	 	;

	MOV	TMOD,	#00000001B	;  
	MOV	IE,	#10000010B	;
	MOV	IP,	#00000010B	;
 	MOV	TH0,	#(HIGH KIND)	; 2ms
	MOV	TL0,	#(LOW KIND)	;

      	SETB	TR0     			;  0
;==========================================================
L2:	NOP			;  (P0___.)
      	MOV	INFS,	#REG	; P
      	MOV	INFS+1,	#3FH	; 0
      	MOV	INFS+2,	#NOPP   	;                         
      	MOV	INFS+3,	#NOPP   	; 
      	MOV	INFS+4,	#NOPP   	; 
L3:   	MOV	PZ,	TIM+1     	;   
      	MOV	PZ+1,	TIM+2    	; 
      	JNB	KR,	L10	;
      	JMP	L3            		;
;==========================================================
L10:   	JMP	L2       		;  
				;  -	
;###################################################################
TIMER:	NOP			;  
 	INC TSEC           		;   50 ms
      	INC R6            		; - .
      	MOV A,TSEC         		;
      	CJNE A,#20,TM1    		; 1.
      	MOV TSEC,#0	     	;
      	MOV A,BUFT         		;
      	CPL A             		; ..
      	MOV BUFT,A         		;
      	JNB FTIM,TM2       		;  
   	DEC R5            		;   .
TM2:	CALL UST         		; /  .
TM1:	RET              		;
;==========================================================
UST:  	NOP               		; /  
      	INC TIM           		; ..
      	MOV A,TIM			;
      	CJNE A,#60,UST1  		;
      	MOV TIM,#0	     	;
      	INC TIM+1         		; ..
      	MOV A,TIM+1		;
      	CJNE A,#60,UST1  		;
      	MOV TIM+1,#0      		;
      	INC TIM+2	      		; .
      	MOV A,TIM+2		;
      	CJNE A,#24,UST1 		;
      	MOV TIM+2,#0      		;
UST1: 	RET               		;
;==========================================================
IND:	NOP			; 
      	PUSH PSW         		; PSW
      	PUSH ACC         		; ACC
      	MOV TH0,#(HIGH KIND)	; 2ms
      	MOV TL0,#(LOW KIND)		;

	INC R2
	CJNE R2,#25,IN1		;  50 ms/2ms=25
	MOV R2,#0
	CALL TIMER

IN1:  	MOV R0,#INFS+8    		; 
      	MOV A,PZ	      		; ..
      	CALL PR          		; -   . .
      	MOV R0,#INFS+6    		;              
      	MOV A,PZ+1        		; .
      	CALL PR          		;
      	MOV A,BUFT        		; ..
      	CJNE A,#80H,IN2   		;
      	ORL INFS+6,A      		;
      	JMP IN3           		; 
IN2:  	ANL INFS+6,A       		;

IN3:  	CALL CON         		;   .

      	POP ACC         		; ACC
      	POP PSW          		; PSW
      	RETI              		;
;==========================================================
PR:   	NOP			; / - 
				;   .      
	CJNE	A,#0,	PR1  	;
        	JMP	PR3          		;
PR1:  	MOV	B,#100		;
    	DIV	AB	          	;
   	MOV	BF1,A	         	; 
	MOV	A,B	      	;
  	MOV	B,	#10	; 
    	DIV	AB	          	;
      	SWAP	A	            	;
 	ADD	A,	B	; 
PR3:  	MOV	BF2,	A	;
      	ANL	A,	#0FH        	;
      	CALL	VR		;
      	MOV	@R0,	A         	;
      	DEC	R0            		;
      	MOV	A,	BF2         	;
      	SWAP	A		;
      	ANL	A,	#0FH        	;
      	CALL	VR		;
      	MOV	@R0,	A	;
      	DEC	R0            		;
      	MOV	A,	BF1         	;
      	CJNE	A,#0,	PR5   	;
      	JMP	PR6		;
PR5:	CALL	VR		;
      	MOV	@R0,	A	;
PR6:	RET			;
;==========================================================
VR:   	MOV DPTR,#KOD		;
      	MOVC A,	@A+DPTR		;
      	RET             		;
;==========================================================
CON:  	NOP               		; /    .
      	MOV R0,BFIS		; ..
      	SETB EI       		; 1 EI .-
	SETB	A3		; .. 
      	MOV R7,#08H		;  
      	MOV A,@R0		;
CON2: 	RLC A             		; . 
	MOV DI,	C		;
 	SETB CLK      		; +1 CLKI \ . 1
      	NOP               		;         \   -
      	NOP               		;         \
       	NOP               		;         \ 
      	NOP               		;         \
     	CLR CLK        		;  0 CLKI \
      	DJNZ R7,	CON2		; . 
      	DEC R0            		; - ..
      	CJNE R0,	#INFS-1,CON1	;
      	MOV R0,	#INFS+8		;
CON1:  	MOV BFIS,	R0		; - ..


       	MOV A,	#0F8H		; . ..
      	ANL P1,	A		;
     	MOV A,	ADIS		; . ..
 	INC	A             		; 
      	CJNE A,#10H,CON4		;
      	MOV A,	#07H		;
	CLR	A3		; .. 
      	JMP	CON7		;
CON4: 	CLR	EI     		;  0 EI .-
      	ORL P1,	A		;
CON7:  	MOV ADIS,	A		;
      	RET               		;
;==========================================================
Z:	NOP			; 
   	DJNZ ZD,Z			;      
      	RET               		;
;==========================================================
KOD:	DB	 3FH           	; 0
      	DB	 06H	           	; 1
      	DB 	 5BH           	; 2
      	DB 	 4FH            	; 3
      	DB	 66H	           	; 4
      	DB	 6DH            	; 5
      	DB	 7DH            	; 6
      	DB 	 07H            	; 7
	DB 	 7FH            	; 8
      	DB 	 6FH            	; 9
;==========================================================
      	END               
     
     
